controllers/EmpleadoController.php
<?php

namespace app\controllers;

use app\models\Departamento;
use app\models\Empleado;
use yii\data\ActiveDataProvider;
use yii\filters\VerbFilter;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\web\Response;

/**
 * EmpleadoController implements the CRUD actions for Empleado model.
 */
class EmpleadoController extends Controller {

    /**
     * @inheritDoc
     */
    public function behaviors() {
        return array_merge(
                parent::behaviors(),
                [
                    'verbs' => [
                        'class' => VerbFilter::className(),
                        'actions' => [
                            'delete' => ['POST'],
                        ],
                    ],
                ]
        );
    }

    /**
     * Lists all Empleado models.
     *
     * @return string
     */
    public function actionIndex() {
        $dataProvider = new ActiveDataProvider([
            'query' => Empleado::find(),
                /*
                  'pagination' => [
                  'pageSize' => 50
                  ],
                  'sort' => [
                  'defaultOrder' => [
                  'codigo' => SORT_DESC,
                  ]
                  ],
                 */
        ]);

        return $this->render('index', [
                    'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Empleado model.
     * @param int $codigo Codigo
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($codigo) {
        return $this->render('view', [
                    'model' => $this->findModel($codigo),
        ]);
    }

    /**
     * Creates a new Empleado model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|Response
     */
    public function actionCreate() {
        $model = new Empleado();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'codigo' => $model->codigo]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
                    'model' => $model,
        ]);
    }

    /**
     * Updates an existing Empleado model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $codigo Codigo
     * @return string|Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($codigo) {
        $model = $this->findModel($codigo);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'codigo' => $model->codigo]);
        }

        return $this->render('update', [
                    'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Empleado model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $codigo Codigo
     * @return Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($codigo) {
        $this->findModel($codigo)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Empleado model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $codigo Codigo
     * @return Empleado the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($codigo) {
        if (($model = Empleado::findOne(['codigo' => $codigo])) !== null) {
            return $model;
        }
        throw new NotFoundHttpException('The requested page does not exist.');
    }

    public function actionConsulta1($id) {
        // creo el activeQuery
        $consulta = Empleado::find()
                ->where([
            "codigo_departamento" => 1
        ]);
        // crear el dataProvider
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);

        if ($id == 1) {
            $vista = "consultas"; // Muestra lso datos en un gridView.
        } else {
            $vista = "listado"; // Muestra los datos en una listaView.
        }

        // el dataProvider lo mandamos a la vista
        return $this->render($vista, [
                    "dataProvider" => $dataProvider,
            "vista" => "empleado/consulta1"
        ]);
    }

    public function actionConsulta2($id) {
        // creo el activeQuery
        // parametrizando la consulta
        $consulta = Empleado::find()
                ->where([
            "OR",
            ["codigo_departamento" => 1],
            ["codigo_departamento" => 2],
        ]);
        // utilizando la consulta como texto
        // $consulta = Empleado::find()
        //        ->where("codigo_departamento=1 OR codigo_departamento=2");
        // crear el dataProvider
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);
        if ($id == 1) {
            $vista = "consultas"; // Muestra lso datos en un gridView.
        } else {
            $vista = "listado"; // Muestra los datos en una listaView.
        }
        // el dataProvider lo mandamos a la vista
        return $this->render($vista, [
                    "dataProvider" => $dataProvider,
                    "vista" => "empleado/consulta2"
        ]);
    }

    public function actionConsulta3($id) {
        // Sacando el codigo del departamento desarrollo.
        $c = Departamento::find()
                        ->where([
                            "nombre" => "Desarrollo"
                        ])->one()->codigo;

        // creo el activeQuery
        // parametrizando la consulta
        $consulta = Empleado::find()
                ->where([
            "codigo_departamento" => $c,
        ]);
        // Hacerlo todo en una sola consulta.
        // $consulta = Empleado::find()->joinWith("codigoDepartamento d", true, "inner join")
        //        ->where(["d.nombre" => "desarrollo"]);
        // crear el dataProvider
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);
        if ($id == 1) {
            $vista = "consultas"; // Muestra lso datos en un gridView.
        } else {
            $vista = "listado"; // Muestra los datos en una listaView.
        }
        // el dataProvider lo mandamos a la vista
        return $this->render($vista, [
                    "dataProvider" => $dataProvider,
                    "vista" => "empleado/consulta3"
        ]);
    }

    public function actionConsulta4() {
        // creo el activeQuery
        $consulta = Empleado::find();
        // crear el dataProvider
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta,
            "pagination" => [
                "pageSize" => 3
            ]
        ]);
        // el dataProvider lo mandamos a la vista
        return $this->render("consultas1", [
                    "dataProvider" => $dataProvider,
                    "campos" => [
                        "codigo",
                        "nombre",
                        "nif",
                        "apellido1",
                        "apellido2",
                        "codigoDepartamento.nombre"
                    ]
        ]);
    }

    public function actionConsulta5() {
        // Opcion 1 usando directamente el joinwith. Creo el activeQuery.
        $consulta = Empleado::find()
                ->joinWith("codigoDepartamento", true, "inner join")
                ->where("gastos>30000");
        // Creo el dataProvider.
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);
        // El dataProvider lo mandamos a la vista.
        return $this->render("consultas1", [
                    "dataProvider" => $dataProvider,
                    "campos" => [
                        "nif",
                        "nombre",
                        "apellido1",
                        "apellido2",
                        "codigoDepartamento.nombre",
                        "codigoDepartamento.gastos"
                    ]
        ]);
        // Fin de la opcion 1.
    }

    public function actionConsulta6() {
        // Creo el activeQuery.
        $consulta = Empleado::find()
                ->joinWith("codigoDepartamento", true, "inner join")
                ->where("presupuesto between 100000 and 150000");
        // Creo el dataProvider.
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);
        // El dataProvider lo mandamos a la vista.
        return $this->render("consultas1", [
                    "dataProvider" => $dataProvider,
                    "campos" => [
                        "nif",
                        "codigo",
                        "nombre",
                        "apellido1",
                        "apellido2",
                        "codigoDepartamento.nombre",
                        "codigoDepartamento.presupuesto"
                    ]
        ]);
    }

    public function actionConsulta7() {
        // Creo el activeQuery.
        $consulta = Empleado::find()
                ->joinWith("codigoDepartamento", true, "inner join")
                ->where("presupuesto between 100000 and 150000 and empleado.nombre like 'A%'");
        // Creo el dataProvider.
        $dataProvider = new ActiveDataProvider([
            "query" => $consulta
        ]);
        // El dataProvider lo mandamos a la vista.
        return $this->render("consultas1", [
                    "dataProvider" => $dataProvider,
                    "campos" => [
                        "nif",
                        "codigo",

controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Empleado;
use yii\data\ActiveDataProvider;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\web\Controller;
use const YII_ENV_TEST;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        return $this->render('index');
    }

    /**
     * 
     * accion preparada para entender los conceptos de
     * consultas desde Yii
     * ActiveQuery
     * ActiveRecord
     * 
     */
    public function actionEmpleados() {

        // active query
        // clase de yii para consultas sql

        $aq = Empleado::find();  // select * from empleado;
        // array de activeRecords
        // Al ejecutar la consulta tengo una array
        // de registros activos
        $vectorAR = $aq->all(); // consulta ejecutada
        // leer
        //echo $vectorAR[1]->nombre; // leo el nombre del segundo empleado
        // escribir
        //$vectorAR[1]->nombre="jose"; 
        //$vectorAR[1]->save();
        // array de arrays

        $vectorArrays = $aq->asArray()->all();

        // leer
        // echo $vectorArrays[1]['nombre'];
        // consulta1
        // buscar el empleado cuyo codigo es 1
        //$consulta1=Empleado::findAll([
        //    'codigo' => 1
        // ]);
        // $consulta1=Empleado::findAll([1]);
        // $consulta1=Empleado::find()
        //         ->where([
        //            'codigo' => 1
        //        ])
        //        ->all();

        $consulta1 = Empleado::find()
                ->where("codigo=1")
                ->all();

        // quiero mostrar los empleados cuyos codigos
        // estan entre 1 y 5

        /* $consulta2=Empleado::find()
          ->where("codigo between 1 and 5")
          ->all();

          $consulta2=Empleado::find()
          ->where("codigo>=1 and codigo<=5")
          ->all(); */

        $consulta2 = Empleado::find()
                ->where([
                    "and",
                    [">=", "codigo", 1], //Primero se coloca el operador.
                    ["<=", "codigo", 5] //Quedarian los codigos mayor o igual a 1 y menor o igual a 5.
                ])
                ->all();

        $consulta2 = Empleado::find()
                ->where([
                    "and",
                    ["codigo" => 1],
                    ["codigo" => 5]
                ])
                ->all();

        $consulta1 = Empleado::find()
                ->where([
            "codigo" => 1
        ]); // activeQuery

        $consulta2 = Empleado::find()
                ->where([
            "and",
            [">=", "codigo", 1], //Primero se coloca el operador.
            ["<=", "codigo", 5] //Quedarian los codigos mayor o igual a 1 y menor o igual a 5.
        ]); //activeQuery
        // listar los empleados cuyo departamento 
        // es 1

        $consulta3 = Empleado::find()
                ->where([
            "codigo_departamento" => 1
        ]);

        $dataProvider = new ActiveDataProvider([
            "query" => $consulta2
        ]);

        return $this->render('empleados', [
                    "registros" => $dataProvider
        ]);
    }

    

}

views/site/empleados.php
<?php

use yii\grid\GridView;

echo GridView::widget([
    "dataProvider" => $registros
]);

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
/** @var yii\web\View $this */
$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Consultas</h1>

        <p class="lead">Realizando consultas de seleccion</p>

    </div>

    <div class="body-content">

        <div class="row">
            <div class="col">
                <h2>Consulta 1</h2>

                <p>Listar los empleados cuyo departamento es 1.</p>

                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta1", "id" => 1], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
            <div class="col">
                <h2>Consulta 2</h2>

                <p>Listar los empleados cuyo departamento es el 1 o el 2.</p>

                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta2", "id" => 1], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
            <div class="col">
                <h2>Consulta 3</h2>

                <p>Listar los empleados cuyo departamento es desarrollo.</p>
                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta3", "id" => 1], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <h2>Consulta 4</h2>

                <p>Listar todos los empleados con el nombre del departamento para el que trabajan.</p>
                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta4"], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
            <div class="col">
                <h2>Consulta 5</h2>

                <p>Listar el nif, el nombre y los apellidos de los empleados que trabajan en un departamento cuyos gastos exceden los 30.000 euros. Ademas quiero el nombre de los departamentos y los gastos.</p>
                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta5"], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
            <div class="col">
                <h2>Consulta 6</h2>

                <p>Listar los empleados (todos los campos) que trabajan en un departamento cuyo presupuesto esta entre 100.000 y 150.000 euros.</p>
                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta6"], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <h2>Consulta 7</h2>

                <p>Listar los empleados (todos los campos) que trabajan en un departamento cuyo presupuesto esta entre 100.000 y 150.000 euros y cuyo nombre (del empleado) comience por A.</p>
                <?=
                \yii\helpers\Html::a("Ejecutar", ["empleado/consulta7"], [
                    "class" => "btn btn-primary"
                ])
                ?>
            </div>
        </div>

    </div>
</div>